Module Flood



#Region "SafeFloodFill"
    ' Flood fill the point.
    Public Sub FloodFill(ByVal bm As Bitmap, ByVal x As Integer, ByVal y As Integer, ByVal new_color As Color)
        ' Get the old and new colors.
        Dim old_color As Color = bm.GetPixel(x, y)

        ' The following "If Then" test was added by Reuben Jollif
        ' to protect the code in case the start pixel
        ' has the same color as the fill color.
        If old_color.ToArgb <> new_color.ToArgb Then
            ' Start with the original point in the stack.
            Dim pts As New Stack(1000)
            pts.Push(New Point(x, y))
            bm.SetPixel(x, y, new_color)

            'Dim sWatch As Stopwatch = Stopwatch.StartNew()
            'sWatch.Start()
            'If sWatch.ElapsedMilliseconds > 30000 Then Exit Do

            ' While the stack is not empty, process a point.
            Do While pts.Count > 0
                Dim pt As Point = DirectCast(pts.Pop(), Point)
                If pt.X > 0 Then SafeCheckPoint(bm, pts, pt.X - 1, pt.Y, old_color, new_color)
                If pt.Y > 0 Then SafeCheckPoint(bm, pts, pt.X, pt.Y - 1, old_color, new_color)
                If pt.X < bm.Width - 1 Then SafeCheckPoint(bm, pts, pt.X + 1, pt.Y, old_color, new_color)
                If pt.Y < bm.Height - 1 Then SafeCheckPoint(bm, pts, pt.X, pt.Y + 1, old_color, new_color)
            Loop

        End If
    End Sub

    ' See if this point should be added to the stack.
    Private Sub SafeCheckPoint(ByVal bm As Bitmap, ByVal pts As Stack, ByVal x As Integer, ByVal y As Integer, ByVal old_color As Color, ByVal new_color As Color)
        Dim clr As Color = bm.GetPixel(x, y)
        If clr.Equals(old_color) Then
            pts.Push(New Point(x, y))
            bm.SetPixel(x, y, new_color)
        End If
    End Sub
#End Region ' SafeFloodFill

End Module
