﻿Imports System.Drawing.Imaging

Public Class FrmCEffect

    Private Sub Label1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label1.Click
        TrackBar1.Value = 0
    End Sub

    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click
        TrackBar2.Value = 0
    End Sub

    Private Sub Label3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label3.Click
        TrackBar3.Value = 0
    End Sub

    Private Sub BrightnessBar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BrightnessBar.Scroll
        txtBrt.Text = BrightnessBar.Value
        isSaved = False
        Dim brt = BrightnessBar.Value / 100

        Dim cm As ColorMatrix = New ColorMatrix(New Single()() _
                                {New Single() {1, 0, 0, 0, 0}, _
                                 New Single() {0, 1, 0, 0, 0}, _
                                 New Single() {0, 0, 1, 0, 0}, _
                                 New Single() {brt, brt, brt, 1, 0}, _
                                 New Single() {0, 0, 0, 0, 1}})


        Try

            Dim tmpBmap = New Bitmap(Form1.Pic1.Image) ' create a copy of the source image 
            Dim imgattr As New ImageAttributes()
            Dim rc As New Rectangle(0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height)
            'Dim g As Graphics = Graphics.FromImage()

            ' associate the ColorMatrix object with an ImageAttributes object
            imgattr.SetColorMatrix(cm)

            ' draw the copy of the source image back over the original image, 
            'applying the ColorMatrix
            G.DrawImage(bmap, rc, 0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height, _
                                   GraphicsUnit.Pixel, imgattr)


        Catch ex As Exception

        End Try
        Form1.Pic1.Refresh()
    End Sub

    Private Sub ContrastBar_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContrastBar.Scroll
        txtContrast.Text = ContrastBar.Value * 5
        isSaved = False
        Dim factor = (ContrastBar.Value + 20) / 20
        Dim factorT = 0.5F * (1.0F - factor)
        Dim cm As ColorMatrix = New ColorMatrix(New Single()() _
                                {New Single() {factor, 0, 0, 0, 0}, _
                                 New Single() {0, factor, 0, 0, 0}, _
                                 New Single() {0, 0, factor, 0, 0}, _
                                 New Single() {0, 0, 0, 1, 0}, _
                                 New Single() {factorT, factorT, factorT, 0, 1}})


        Try
            Dim tmpBmap = New Bitmap(Form1.Pic1.Image) ' create a copy of the source image 
            Dim imgattr As New ImageAttributes()
            Dim rc As New Rectangle(0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height)
      
            ' associate the ColorMatrix object with an ImageAttributes object
            imgattr.SetColorMatrix(cm)

            ' draw the copy of the source image back over the original image, 
            'applying the ColorMatrix
            g.DrawImage(bmap, rc, 0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height, _
                                   GraphicsUnit.Pixel, imgattr)


        Catch ex As Exception

        End Try
        Form1.Pic1.Refresh()

    End Sub


    Private Sub TrackBar1_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TrackBar1.Scroll
        colorBalance()
    End Sub

    Private Sub ChkRed_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkRed.CheckedChanged
        resetColor()
    End Sub

    Private Sub ChkGreen_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkGreen.CheckedChanged
        resetColor()
    End Sub

    Private Sub ChkBlue_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ChkBlue.CheckedChanged
        resetColor()
    End Sub
    Private Sub TrackBar1_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TrackBar1.ValueChanged
        colorBalance()
    End Sub
    Private Sub TrackBar2_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TrackBar2.ValueChanged
        colorBalance()
    End Sub
    Private Sub TrackBar3_ValueChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles TrackBar3.ValueChanged
        colorBalance()
    End Sub
    Sub resetColor()
        isSaved = False

        Dim cm As ColorMatrix = New ColorMatrix(New Single()() _
                       {New Single() {ChkRed.CheckState, 0, 0, 0, 0}, _
                        New Single() {0, ChkGreen.CheckState, 0, 0, 0}, _
                        New Single() {0, 0, ChkBlue.CheckState, 0, 0}, _
                        New Single() {0, 0, 0, 1, 0}, _
                        New Single() {0, 0, 0, 0, 1}})


        Try
            Dim tmpBmap = New Bitmap(Form1.Pic1.Image) ' create a copy of the source image 
            Dim imgattr As New ImageAttributes()
            Dim rc As New Rectangle(0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height)
            Dim g As Graphics = Graphics.FromImage(Form1.Pic1.Image)

            ' associate the ColorMatrix object with an ImageAttributes object
            imgattr.SetColorMatrix(cm)

            ' draw the copy of the source image back over the original image, 
            'applying the ColorMatrix
            g.DrawImage(bmap, rc, 0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height, _
                                   GraphicsUnit.Pixel, imgattr)

            TrackBar1.Value = 0
            TrackBar2.Value = 0
            TrackBar3.Value = 0

        Catch ex As Exception
            MDIParent1.Status1.Text = "Error: " & ex.Message
        End Try
        Form1.Pic1.Refresh()

    End Sub
    Sub colorBalance()
        isSaved = False

        Dim brt1 = TrackBar1.Value / 100
        Dim brt2 = TrackBar2.Value / 100
        Dim brt3 = TrackBar3.Value / 100
        Dim cm As ColorMatrix = New ColorMatrix(New Single()() _
                                {New Single() {1, 0, 0, 0, 0}, _
                                 New Single() {0, 1, 0, 0, 0}, _
                                 New Single() {0, 0, 1, 0, 0}, _
                                 New Single() {0, 0, 0, 1, 0}, _
                                 New Single() {brt1, brt2, brt3, 0, 1}})


        Try
            Dim tmpbmap = New Bitmap(Form1.Pic1.Image) ' create a copy of the source image 
            Dim imgattr As New ImageAttributes()
            Dim rc As New Rectangle(0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height)
            Dim g As Graphics = Graphics.FromImage(Form1.Pic1.Image)

            ' associate the ColorMatrix object with an ImageAttributes object
            imgattr.SetColorMatrix(cm)

            ' draw the copy of the source image back over the original image, 
            'applying the ColorMatrix
            g.DrawImage(bmap, rc, 0, 0, Form1.Pic1.Image.Width, Form1.Pic1.Image.Height, _
                                   GraphicsUnit.Pixel, imgattr)


        Catch ex As Exception
            MDIParent1.Status1.Text = "Error: " & ex.Message
        End Try
        Form1.Pic1.Refresh()

        'MDIParent1.Status1.Text = "Ready"
        'AddtoHistory("Color Balance")
    End Sub

  
End Class