﻿Imports System.Windows.Forms
Imports Microsoft
Imports System.Drawing.Imaging

Public Class MDIParent1
    Dim OpenFileDialog As New OpenFileDialog
    Dim TextrueOpenFileDialog As New OpenFileDialog
    Private Sub NewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click
        myCommand = "New"
        FrmNew.Show()
    End Sub
    Private Sub OpenFile(ByVal sender As Object, ByVal e As EventArgs) Handles OpenToolStripMenuItem.Click
        FileOpen()
    End Sub
    Sub FileOpen()
        OpenFileDialog.Filter = "All Picture Files|*.bmp;*.png;*.jpeg;*.jpg;*.tif;*.tiff|JPEG Files (*.jpeg;*.jpg)|*.jpeg;*.jpg|PNG Files (*.PNG)|*.PNG|Bitmap Files (*.bmp)|*.bmp|All Files|*.*"
        If (OpenFileDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            Try
                Form1.Close()
                frmHistory.ListHistory.Items.Clear()
                frmHistory.ListName.Items.Clear()
                Form1.MdiParent = Me
                Dim FileName As String = OpenFileDialog.FileName
                Form1.Pic1.Image = Image.FromFile(FileName)
                Form1.Text = IO.Path.GetFileName(FileName)
                Form1.Pic1.Refresh()
                myCommand = "Open"
                frmHistory.ListHistory.Items.Clear()
                Form1.Show()
            Catch ex As Exception
                MsgBox("Could not open '" & OpenFileDialog.FileName & "'", MsgBoxStyle.Critical, "PhotoEdit")
                Status1.Text = "Error: " & ex.Message
            End Try
        End If

    End Sub
#Region "Save"
    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles SaveAsToolStripMenuItem.Click
        Try

            SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
            SaveFileDialog1.Filter = "Bitmap Files (*.bmp)|*.bmp|JPEG Files (*.JPEG;*.JPG;*.JPE)|*.JPG|CompuServe GIF Files (*.GIF)|*.GIF|PNG Files (*.PNG)|*.PNG"
            bmap = New Bitmap(CInt(bmap.Width * zoomFactor), _
            CInt(bmap.Height * zoomFactor))
            If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                Dim FileName As String = SaveFileDialog1.FileName
                If IO.Path.HasExtension(FileName) Then
                    If SaveFileDialog1.FilterIndex = 1 Then
                        Form1.Pic1.Image.Save(FileName, Imaging.ImageFormat.Bmp)
                    ElseIf SaveFileDialog1.FilterIndex = 2 Then
                        Form1.Pic1.Image.Save(FileName, Imaging.ImageFormat.Jpeg)
                    ElseIf SaveFileDialog1.FilterIndex = 3 Then
                        Form1.Pic1.Image.Save(FileName, Imaging.ImageFormat.Gif)
                    ElseIf SaveFileDialog1.FilterIndex = 4 Then
                        Form1.Pic1.Image.Save(FileName, Imaging.ImageFormat.Png)
                    Else
                        Form1.Pic1.Image.Save(FileName)
                    End If

                Else
                    If SaveFileDialog1.FilterIndex = 1 Then
                        Form1.Pic1.Image.Save(FileName & ".bmp", Imaging.ImageFormat.Bmp)
                    ElseIf SaveFileDialog1.FilterIndex = 2 Then
                        Form1.Pic1.Image.Save(FileName & ".jpg", Imaging.ImageFormat.Jpeg)
                    ElseIf SaveFileDialog1.FilterIndex = 3 Then
                        Form1.Pic1.Image.Save(FileName & ".gif", Imaging.ImageFormat.Gif)
                    ElseIf SaveFileDialog1.FilterIndex = 4 Then
                        Form1.Pic1.Image.Save(FileName & ".png", Imaging.ImageFormat.Png)
                    Else
                        Form1.Pic1.Image.Save(FileName)
                    End If

                End If
                isSaved = True
            Else
                'Do Nothing
            End If


        Catch ex As Exception
            Status1.Text = "Error: " & ex.Message
        End Try

    End Sub
    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        Try

            SaveFileDialog1.Filter = "All Files (*.*)|*.*"

            If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
                Dim FileName As String = SaveFileDialog1.FileName
                Form1.Pic1.Image.Save(FileName, Imaging.ImageFormat.Png)
                isSaved = True
            End If
        Catch ex As Exception
            Status1.Text = "Error: " & ex.Message
        End Try

    End Sub
#End Region
#Region "MenuItem"
    Private Sub ExitToolsStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ExitToolStripMenuItem.Click
        Me.Close()
    End Sub


    Private Sub ToolBarToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles ToolBarToolStripMenuItem.Click
        If ToolBarToolStripMenuItem.CheckState = CheckState.Checked Then
            ToolStrip1.Visible = True
        ElseIf ToolBarToolStripMenuItem.CheckState = CheckState.Unchecked Then
            ToolStrip1.Visible = False
        End If
    End Sub

    Private Sub ToolboxToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ToolboxToolStripMenuItem.Click
        If ToolboxToolStripMenuItem.CheckState = CheckState.Checked Then
            panelToolBox.Visible = True
            FrmCEffect.Left = Me.Width - (FrmColor.Width + 74)
            FrmColor.Left = Me.Width - (FrmColor.Width + 74)
            frmHistory.Left = Me.Width - (FrmColor.Width + 74)
        ElseIf ToolboxToolStripMenuItem.CheckState = CheckState.Unchecked Then
            panelToolBox.Visible = False
            FrmCEffect.Left = Me.Width - (FrmColor.Width + 14)
            FrmColor.Left = Me.Width - (FrmColor.Width + 14)
            frmHistory.Left = Me.Width - (FrmColor.Width + 14)
        End If
    End Sub
    Private Sub HistoryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HistoryToolStripMenuItem.Click
        If HistoryToolStripMenuItem.CheckState = CheckState.Checked Then
            frmHistory.MdiParent = Me
            frmHistory.Left = Me.Width - (FrmColor.Width + 14)
            frmHistory.Top = FrmCEffect.Bottom
            frmHistory.Show()
        ElseIf HistoryToolStripMenuItem.CheckState = CheckState.Unchecked Then
            frmHistory.Hide()
        End If
    End Sub

    Private Sub ColorBoxToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ColorBoxToolStripMenuItem.Click
        If ColorBoxToolStripMenuItem.CheckState = CheckState.Checked Then
            FrmColor.MdiParent = Me
            FrmColor.Left = Me.Width - FrmColor.Width - 14
            FrmColor.Show()
        ElseIf ColorBoxToolStripMenuItem.CheckState = CheckState.Unchecked Then
            FrmColor.Hide()
        End If

    End Sub
    Private Sub EffectToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EffectToolStripMenuItem.Click
        If EffectToolStripMenuItem.CheckState = CheckState.Checked Then
            FrmCEffect.MdiParent = Me
            FrmCEffect.Left = Me.Width - (FrmColor.Width + 14)
            FrmCEffect.Top = FrmColor.Height
            FrmCEffect.TabPage1.Enabled = False
            FrmCEffect.TabPage2.Enabled = False
            FrmCEffect.Show()
        ElseIf EffectToolStripMenuItem.CheckState = CheckState.Unchecked Then
            FrmCEffect.Hide()
        End If
    End Sub

    Private Sub CascadeToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.Cascade)
    End Sub

    Private Sub TileVerticalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.TileVertical)
    End Sub

    Private Sub TileHorizontalToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.TileHorizontal)
    End Sub

    Private Sub ArrangeIconsToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs)
        Me.LayoutMdi(MdiLayout.ArrangeIcons)
    End Sub
    Private Sub UndoToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles UndoToolStripMenuItem1.Click
        undo()
    End Sub

    Private Sub RotateLeftToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RotateLeftToolStripMenuItem.Click
        AddtoHistory("Rotate CW")
        Form1.Pic1.Image.RotateFlip(RotateFlipType.Rotate270FlipNone)
        Form1.Pic1.Refresh()
        Form1.Width = Form1.Pic1.Image.Width
        Form1.Height = Form1.Pic1.Image.Height
    End Sub

    Private Sub RotateRightToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RotateRightToolStripMenuItem.Click
        AddtoHistory("Rotate CCW")
        Form1.Pic1.Image.RotateFlip(RotateFlipType.Rotate90FlipNone)
        Form1.Pic1.Refresh()
        Form1.Width = Form1.Pic1.Image.Width
        Form1.Height = Form1.Pic1.Image.Height
    End Sub

    Private Sub FlipHorizontalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FlipHorizontalToolStripMenuItem.Click
        AddtoHistory("Flip Horizontal")
        Form1.Pic1.Image.RotateFlip(RotateFlipType.RotateNoneFlipX)
        Form1.Pic1.Refresh()
    End Sub

    Private Sub FlipVerticalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FlipVerticalToolStripMenuItem.Click
        AddtoHistory("Flip Vertical")
        Form1.Pic1.Image.RotateFlip(RotateFlipType.RotateNoneFlipY)
        Form1.Pic1.Refresh()
    End Sub
#End Region
#Region "ToolBox"

    Private Sub ButSelect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButSelect.Click
        myTool = "Select"
        i = 0
        Me.SelectedToolButton.Image = ButSelect.Image
        Form1.Cursor = Cursors.Cross
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False
    End Sub

    Private Sub ButPen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButPen.Click
        myTool = "Pen"
        i = 0
        Me.SelectedToolButton.Image = ButPen.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\Pencil.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub

    Private Sub ButBrush_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButBrush.Click
        myTool = "Brush"
        i = 0
        Me.SelectedToolButton.Image = ButBrush.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\Brush.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False
    End Sub

    Private Sub ButEraser_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButEraser.Click
        myTool = "Eraser"
        i = 0
        Me.SelectedToolButton.Image = ButEraser.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\Eraser.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub

    Private Sub ButPicker_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButPicker.Click
        myTool = "Picker"
        i = 0
        Me.SelectedToolButton.Image = ButPicker.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\Picker.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub

    Private Sub ButCursor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButCursor.Click
        myTool = "Cursor"
        i = 0
        Me.SelectedToolButton.Image = ButCursor.Image
        Form1.Cursor = Cursors.Default
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub

    Private Sub ButTxt_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButTxt.Click
        myTool = "Text"
        i = 0
        Me.SelectedToolButton.Image = ButTxt.Image
        Form1.Cursor = Cursors.Default
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = True
        Me.RegularToolStripMenuItem.Visible = True
        Me.ShadowToolStripMenuItem.Visible = True

        ToolStripTextBox1.Visible = True

    End Sub

    Private Sub ButLine_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButLine.Click
        myTool = "Line"
        i = 0
        Me.SelectedToolButton.Image = ButLine.Image
        Form1.Cursor = Cursors.Cross
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False
    End Sub

    Private Sub ButReg_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButReg.Click
        myTool = "Regtangle"
        i = 0
        Me.SelectedToolButton.Image = ButReg.Image
        Form1.Cursor = Cursors.Cross
        Me.FillToolStripMenuItem.Visible = True
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub

    Private Sub ButEllipse_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButEllipse.Click
        myTool = "Ellipse"
        i = 0
        Me.SelectedToolButton.Image = ButEllipse.Image
        Form1.Cursor = Cursors.Cross
        Me.FillToolStripMenuItem.Visible = True
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub


    Private Sub ButMove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButMove.Click
        myTool = "Move"
        i = 0
        Me.SelectedToolButton.Image = ButMove.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\Move.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub

    Private Sub ButPolygon_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButPolygon.Click
        myTool = "Polygon"
        i = 0
        Me.SelectedToolButton.Image = ButLine.Image
        Form1.Cursor = Cursors.Cross
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub

    Private Sub ButFloodfill_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButFloodfill.Click
        myTool = "Floodfill"
        i = 0
        Me.SelectedToolButton.Image = ButFloodfill.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\FloodFill.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

    End Sub
    Private Sub ButHand_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButHand.Click
        myTool = "Hand"
        i = 0
        Me.SelectedToolButton.Image = ButHand.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\hand.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False
    End Sub

    Private Sub ButCrop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButCrop.Click
        myTool = "Crop"
        i = 0
        Me.SelectedToolButton.Image = ButCrop.Image
        Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\crop.cur"))
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False
    End Sub
#End Region
#Region "Image Processing"



    Private Sub SharpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SharpenToolStripMenuItem.Click
        Status1.Text = "Processing"
        bmap = New Bitmap(Form1.Pic1.Image)
        Form1.Pic1.Image = bmap
        Dim tempbmp As New Bitmap(Form1.Pic1.Image)
        Dim DX As Integer = 1
        Dim DY As Integer = 1
        Dim red, green, blue As Integer
        ProgressBar1.Visible = True
        Dim i, j As Integer
        Try

            With tempbmp
                For i = y1 + DX + 1 To y2 - DX - 1
                    For j = x1 + DY + 1 To x2 - DY - 1
                        red = CInt(.GetPixel(j, i).R) + 0.5 * CInt((.GetPixel(j, i).R) - CInt(.GetPixel(j - DX, i - DY).R))
                        green = CInt(.GetPixel(j, i).G) + 0.7 * CInt((.GetPixel(j, i).G) - CInt(.GetPixel(j - DX, i - DY).G))
                        blue = CInt(.GetPixel(j, i).B) + 0.5 * CInt((.GetPixel(j, i).B - CInt(.GetPixel(j - DX, i - DY).B)))
                        red = Math.Min(Math.Max(red, 0), 255)
                        green = Math.Min(Math.Max(green, 0), 255)
                        blue = Math.Min(Math.Max(blue, 0), 255)
                        bmap.SetPixel(j, i, Color.FromArgb(red, green, blue))
                    Next
                    If i Mod 10 = 0 Then
                        Form1.Pic1.Invalidate()
                        ProgressBar1.Value = Int(100 * i / (Form1.Pic1.Image.Height - 2))
                        Form1.Pic1.Refresh()
                    End If
                Next
            End With

        Catch ex As Exception
            Status1.Text = ex.Message
        End Try
        Form1.Pic1.Refresh()
        ProgressBar1.Visible = False
        Status1.Text = "Ready"
        AddtoHistory("Sharpen")
    End Sub

    Private Sub SmoothToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SmoothToolStripMenuItem.Click
        Status1.Text = "Processing"
        bmap = New Bitmap(Form1.Pic1.Image)
        Form1.Pic1.Image = bmap
        Dim tempbmp As New Bitmap(Form1.Pic1.Image) 'BackgroundImage
        Dim DX As Integer = 1
        Dim DY As Integer = 1
        Dim red, green, blue As Integer
        Dim i, j As Integer
        ProgressBar1.Visible = True
        Try
            With tempbmp
                For i = y1 + DX + 1 To y2 - DX - 1
                    For j = x1 + DY + 1 To x2 - DY - 1
                        red = CInt((CInt(.GetPixel(j - 1, i - 1).R) + _
                                CInt(.GetPixel(j - 1, i).R) + _
                                CInt(.GetPixel(j - 1, i + 1).R) + _
                                CInt(.GetPixel(j, i - 1).R) + _
                                CInt(.GetPixel(j, i).R) + _
                                CInt(.GetPixel(j, i + 1).R) + _
                                CInt(.GetPixel(j + 1, i - 1).R) + _
                                CInt(.GetPixel(j + 1, i).R) + _
                                CInt(.GetPixel(j + 1, i + 1).R)) / 9)

                        green = CInt((CInt(.GetPixel(j - 1, i - 1).G) + _
                                CInt(.GetPixel(j - 1, i).G) + _
                                CInt(.GetPixel(j - 1, i + 1).G) + _
                                CInt(.GetPixel(j, i - 1).G) + _
                                CInt(.GetPixel(j, i).G) + _
                                CInt(.GetPixel(j, i + 1).G) + _
                                CInt(.GetPixel(j + 1, i - 1).G) + _
                                CInt(.GetPixel(j + 1, i).G) + _
                                CInt(.GetPixel(j + 1, i + 1).G)) / 9)

                        blue = CInt((CInt(.GetPixel(j - 1, i - 1).B) + _
                                CInt(.GetPixel(j - 1, i).B) + _
                                CInt(.GetPixel(j - 1, i + 1).B) + _
                                CInt(.GetPixel(j, i - 1).B) + _
                                CInt(.GetPixel(j, i).B) + _
                                CInt(.GetPixel(j, i + 1).B) + _
                                CInt(.GetPixel(j + 1, i - 1).B) + _
                                CInt(.GetPixel(j + 1, i).B) + _
                                CInt(.GetPixel(j + 1, i + 1).B)) / 9)
                        red = Math.Min(Math.Max(red, 0), 255)
                        green = Math.Min(Math.Max(green, 0), 255)
                        blue = Math.Min(Math.Max(blue, 0), 255)
                        bmap.SetPixel(j, i, Color.FromArgb(red, green, blue))
                    Next
                    If i Mod 10 = 0 Then
                        Form1.Pic1.Invalidate()
                        Form1.Pic1.Refresh()
                        ProgressBar1.Value = Math.Min(Int(100 * i / (Form1.Pic1.Image.Height - 2)), 100)
                    End If
                Next
            End With

        Catch ex As Exception
            Status1.Text = ex.Message
        End Try
        Form1.Pic1.Refresh()
        ProgressBar1.Visible = False
        Status1.Text = "Ready"
        AddtoHistory("Smooth")
    End Sub

    Private Sub DiffuseToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DiffuseToolStripMenuItem.Click
        Status1.Text = "Processing"
        bmap = New Bitmap(Form1.Pic1.Image)
        Form1.Pic1.Image = bmap

        Dim tempbmp As New Bitmap(Form1.Pic1.Image)
        Dim i As Integer, j As Integer
        Dim DX As Integer
        Dim DY As Integer
        Dim red As Integer, green As Integer, blue As Integer
        ProgressBar1.Visible = True
        Try
            With tempbmp
                For i = y1 + 3 To y1 - 3
                    For j = x1 + 3 To x2 - 3
                        DX = Rnd() * 4 - 2
                        DY = Rnd() * 4 - 2
                        red = .GetPixel(j + DX, i + DY).R
                        green = .GetPixel(j + DX, i + DY).G
                        blue = .GetPixel(j + DX, i + DY).B
                        bmap.SetPixel(j, i, Color.FromArgb(red, green, blue))
                    Next
                    If i Mod 10 = 0 Then
                        Form1.Pic1.Invalidate()
                        Form1.Pic1.Refresh()
                        ProgressBar1.Value = Math.Min(Int(100 * i / (Form1.Pic1.Image.Height - 2)), 100)
                    End If
                Next
            End With
        Catch ex As Exception
            Status1.Text = ex.Message
        End Try
        Form1.Pic1.Refresh()
        ProgressBar1.Visible = False
        Status1.Text = "Ready"
        AddtoHistory("Diffuse")
    End Sub



    Private Sub GrayScaleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GrayScaleToolStripMenuItem.Click
        Status1.Text = "Processing"
        bmap = New Bitmap(Form1.Pic1.Image)
        Form1.Pic1.Image = bmap
        Dim tempbmp As New Bitmap(Form1.Pic1.Image) 'BackgroundImage
        Dim iColor As Integer
        Dim red, green, blue As Integer
        Dim i, j As Integer
        ProgressBar1.Visible = True
        Try
            With tempbmp
                For j = y1 + 1 To y2 - 1
                    For i = x1 + 1 To x2 - 1

                        red = .GetPixel(i, j).R
                        green = .GetPixel(i, j).G
                        blue = .GetPixel(i, j).B

                        iColor = (blue + green + blue) / 3

                        bmap.SetPixel(i, j, Color.FromArgb(iColor, iColor, iColor))
                    Next
                    If j Mod 10 = 0 Then
                        Form1.Pic1.Invalidate()
                        Form1.Pic1.Refresh()
                        ProgressBar1.Value = Math.Min(Int(100 * i / (Form1.Pic1.Image.Height - 2)), 100)
                    End If
                Next
            End With
        Catch ex As Exception
            Status1.Text = "Error: " & ex.Message
        End Try
        Form1.Pic1.Refresh()
        ProgressBar1.Visible = False
        Status1.Text = "Ready"
        AddtoHistory("GrayScale")
    End Sub
    Private Sub NegativeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NegativeToolStripMenuItem.Click

        Status1.Text = "Processing"
        bmap = New Bitmap(Form1.Pic1.Image)
        Form1.Pic1.Image = bmap
        Dim tempbmp As New Bitmap(Form1.Pic1.Image) 'BackgroundImage
        Dim red, green, blue As Integer
        Dim i, j As Integer
        ProgressBar1.Visible = True
        Try
            With tempbmp
                For j = y1 + 1 To y2 - 1
                    For i = x1 + 1 To x2 - 1

                        red = 255 - .GetPixel(i, j).R
                        green = 255 - .GetPixel(i, j).G
                        blue = 255 - .GetPixel(i, j).B


                        bmap.SetPixel(i, j, Color.FromArgb(red, green, blue))
                    Next
                    If j Mod 10 = 0 Then
                        Form1.Pic1.Invalidate()
                        Form1.Pic1.Refresh()
                        ProgressBar1.Value = Math.Min(Int(100 * i / (Form1.Pic1.Image.Height - 2)), 100)
                    End If
                Next
            End With
        Catch ex As Exception
            Status1.Text = "Error: " & ex.Message
        End Try
        Form1.Pic1.Refresh()
        ProgressBar1.Visible = False
        Status1.Text = "Ready"
        AddtoHistory("Negative")
    End Sub

    Private Sub TransToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TransToolStripMenuItem.Click
        TransDialog.Show()
    End Sub
#End Region

    Private Sub MDIParent1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.DoubleClick
        FileOpen()
    End Sub

    Private Sub MDIParent1_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragDrop

        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            Dim FileName As String() = CType(e.Data.GetData(DataFormats.FileDrop), String())
            Form1.Close()
            frmHistory.ListHistory.Items.Clear()
            frmHistory.ListName.Items.Clear()
            Form1.MdiParent = Me
            Form1.Pic1.Image = Image.FromFile(FileName(0))
            Form1.Text = IO.Path.GetFileName(FileName(0))
            Form1.Pic1.Refresh()
            x1 = 0
            y1 = 0
            x2 = Form1.Pic1.Image.Width
            y2 = Form1.Pic1.Image.Height
            myCommand = "Open"
            frmHistory.ListHistory.Items.Clear()
            Form1.Show()
        End If

    End Sub

    Private Sub MDIParent1_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles Me.DragEnter
        'SET THE PROPER ACTION FOR FILE DROP....BY USING THE FILEDROP METHOD TO COPY
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then
            e.Effect = DragDropEffects.Move
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub MDIParent1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed
        On Error Resume Next
        My.Computer.FileSystem.DeleteDirectory(historyPath & "\Photo", FileIO.DeleteDirectoryOption.DeleteAllContents)
    End Sub

    Private Sub MDIParent1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        zoomFactor = 1
        Regular = True
        Reflect = False
        RegularToolStripMenuItem.CheckState = CheckState.Checked
        myBackBrush = Brushes.Gray

        OpenFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
        SaveFileDialog1.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments

        myTool = "Cursor"

        FrmCEffect.MdiParent = Me
        FrmCEffect.Left = Me.Width - (FrmColor.Width + 74)
        FrmCEffect.Top = FrmColor.Height
        FrmCEffect.TabPage1.Enabled = False
        FrmCEffect.TabPage2.Enabled = False
        FrmCEffect.Show()

        FrmColor.MdiParent = Me
        FrmColor.Left = Me.Width - (FrmColor.Width + 74)
        FrmColor.Show()

        frmHistory.MdiParent = Me
        frmHistory.Left = Me.Width - (FrmColor.Width + 74)
        frmHistory.Top = FrmCEffect.Bottom
        frmHistory.Show()

        Form1.MdiParent = Me

        My.Computer.FileSystem.CreateDirectory(historyPath & "\Photo")
        If Command() <> "" Then
            Dim tCommand = Command()
            tCommand = VisualBasic.Left(tCommand, tCommand.Length - 1)
            tCommand = VisualBasic.Right(tCommand, tCommand.Length - 1)

            Try
                Form1.Pic1.Image = Image.FromFile(tCommand)
                myCommand = "Open"
                Form1.Show()
            Catch ex As Exception
                Status1.Text = ex.Message
            End Try
        End If
    End Sub

    Private Sub ResizeToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ResizeToolStripMenuItem.Click
        Try
            imgResize.TextBox1.Text = Form1.Pic1.Image.Width
            imgResize.TextBox2.Text = Form1.Pic1.Image.Height
            imgResize.MdiParent = Me
            imgResize.Show()
        Catch ex As Exception
            Status1.Text = "Error: " & ex.Message
        End Try
    End Sub

    Private Sub FontBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FontBox.Click
        If FontDialog1.ShowDialog(Me) = Windows.Forms.DialogResult.OK Then
            'ToolStripTextBox1.Font = FontDialog1.Font
            Form1.Refresh()
        End If
    End Sub

   

    Private Sub MDIParent1_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown
        myColor = Color.Black
        myEraserColor = Color.White
        myBrush = Brushes.Black
    End Sub

    Private Sub RedoToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RedoToolStripMenuItem1.Click
        Redo()
    End Sub

    Private Sub NormalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NormalToolStripMenuItem.Click
        zoomFactor = 1
        Zoom(zoomFactor)
        Form1.Width = Form1.Pic1.Image.Width
        Form1.Height = Form1.Pic1.Image.Height

    End Sub

    Private Sub InToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InToolStripMenuItem.Click
        ZoomP()
    End Sub

    Private Sub OuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OuToolStripMenuItem.Click
        ZoomN()
    End Sub

    Private Sub ContentsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContentsToolStripMenuItem.Click
        Try

            Process.Start(myPath & "\Help\hlp.html")

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        AboutBox1.Show()
    End Sub
    Private Sub CopyToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToolStripMenuItem1.Click
        On Error Resume Next
        If (Form1.Pic1.Image.Width = SelectRect.Width) OrElse (Form1.Pic1.Image.Height = SelectRect.Height) Then
            Clipboard.SetDataObject(Form1.Pic1.Image)
        Else
            Using copyBMP As Bitmap = New Bitmap(SelectRect.Width, SelectRect.Height)
                Using gr As Graphics = Graphics.FromImage(copyBMP)
                    gr.DrawImage(bmap, 0, 0)
                End Using
                Clipboard.SetImage(copyBMP)
            End Using
        End If

    End Sub

    Private Sub PasteToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PasteToolStripMenuItem1.Click
        Try
            If Clipboard.ContainsImage Then
                Form1.Cursor = New Cursor(LoadCursorFromFile(myPath & "\data\Move.cur"))
                myTool = "Paste"
                paste = New Bitmap(Clipboard.GetImage)
                paste.MakeTransparent(Color.Transparent)

                ' Set the paste's initial location.
                pasteLocation = New Rectangle(0, 0, paste.Width, paste.Height)
                Form1.Pic1.CreateGraphics.DrawImage(paste, pasteLocation)

            End If
        Catch ex As Exception
            Status1.Text = "Error:" & ex.Message
        End Try
    End Sub

    Private Sub MakeTransToolSMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MakeTransToolSMenuItem.Click
        MakeTransparent()
    End Sub

    Private Sub FillToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FillToolStripMenuItem.Click
        If Fill = True Then
            Fill = False
            ToolStripStyle.Visible = False
            FillToolStripMenuItem.CheckState = CheckState.Unchecked
        Else
            Fill = True
            If myStyle = Nothing Then myStyle = "NoStyle"
            ToolStripStyle.Visible = True
            FillToolStripMenuItem.CheckState = CheckState.Checked
        End If
    End Sub

    Private Sub RegularToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RegularToolStripMenuItem.Click
        If Regular = True Then
            Regular = False
            RegularToolStripMenuItem.CheckState = CheckState.Unchecked
        Else
            Regular = True
            Reflect = False
            Shadow = False
            RegularToolStripMenuItem.CheckState = CheckState.Checked
            ReflectTextToolStripMenuItem.CheckState = CheckState.Unchecked
            ShadowToolStripMenuItem.CheckState = CheckState.Unchecked
        End If
    End Sub

    Private Sub ReflectTextToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ReflectTextToolStripMenuItem.Click
        If Reflect = True Then
            Reflect = False
            ReflectTextToolStripMenuItem.CheckState = CheckState.Unchecked
        Else
            Reflect = True
            Regular = False
            Shadow = False
            ReflectTextToolStripMenuItem.CheckState = CheckState.Checked
            RegularToolStripMenuItem.CheckState = CheckState.Unchecked
            ShadowToolStripMenuItem.CheckState = CheckState.Unchecked

        End If
    End Sub

    Private Sub ShadowToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ShadowToolStripMenuItem.Click
        If Shadow = True Then
            Shadow = False
            ReflectTextToolStripMenuItem.CheckState = CheckState.Unchecked
        Else
            Shadow = True
            Regular = False
            Reflect = False
            ShadowToolStripMenuItem.CheckState = CheckState.Checked
            RegularToolStripMenuItem.CheckState = CheckState.Unchecked
            ReflectTextToolStripMenuItem.CheckState = CheckState.Unchecked

        End If
    End Sub

    Private Sub myBackColor_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles myBackColor.Click
        ColorDialog.Left = Me.Left + 240
        ColorDialog.Top = Me.Top + 72
        ColorDialog.Show()
    End Sub


    Private Sub IndexToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IndexToolStripMenuItem.Click
        Try
            Process.Start(myPath & "\Help\hlp.html")

        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub NoStyleToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NoStyleToolStripMenuItem.Click
        unCheckedOthers()
        NoStyleToolStripMenuItem.CheckState = CheckState.Checked
        myStyle = "NoStyle"
    End Sub
    Private Sub HorizontalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HorizontalToolStripMenuItem.Click
        unCheckedOthers()
        HorizontalToolStripMenuItem.CheckState = CheckState.Checked
        myStyle = "Horizontal"
    End Sub

    Private Sub VerticalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles VerticalToolStripMenuItem.Click
        unCheckedOthers()
        VerticalToolStripMenuItem.CheckState = CheckState.Checked
        myStyle = "Vertical"
    End Sub

    Private Sub TextureToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextureToolStripMenuItem.Click
        If (TextrueOpenFileDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            unCheckedOthers()
            TextureToolStripMenuItem.CheckState = CheckState.Checked

            TextrueOpenFileDialog.Filter = "All Picture Files|*.bmp;*.png;*.jpeg;*.jpg;*.tif;*.tiff|JPEG Files (*.jpeg;*.jpg)|*.jpeg;*.jpg|PNG Files (*.PNG)|*.PNG|Bitmap Files (*.bmp)|*.bmp|All Files|*.*"
            textrueImg = Image.FromFile(TextrueOpenFileDialog.FileName)
            ToolStripStyle.Image = textrueImg
            myStyle = "Texture"
        End If
    End Sub

    Private Sub FDiagonalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FDiagonalToolStripMenuItem.Click
        unCheckedOthers()
        FDiagonalToolStripMenuItem.CheckState = CheckState.Checked
        myStyle = "FDiagonal"
    End Sub

    Private Sub BDiagonalToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BDiagonalToolStripMenuItem.Click
        unCheckedOthers()
        BDiagonalToolStripMenuItem.CheckState = CheckState.Checked
        myStyle = "BDiagonal"
    End Sub
    Sub unCheckedOthers()
        HorizontalToolStripMenuItem.CheckState = CheckState.Unchecked
        VerticalToolStripMenuItem.CheckState = CheckState.Unchecked
        TextureToolStripMenuItem.CheckState = CheckState.Unchecked
        NoStyleToolStripMenuItem.CheckState = CheckState.Unchecked
        FDiagonalToolStripMenuItem.CheckState = CheckState.Unchecked
        BDiagonalToolStripMenuItem.CheckState = CheckState.Unchecked
    End Sub

    Private Sub ToolStripTextBox1_TextChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles ToolStripTextBox1.TextChanged
        Form1.Refresh()
    End Sub

    Private Sub SelectAllToolStripMenuItem1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SelectAllToolStripMenuItem1.Click
        myTool = "Select"
        i = 0
        Me.SelectedToolButton.Image = ButSelect.Image
        Form1.Cursor = Cursors.Cross
        Me.FillToolStripMenuItem.Visible = False
        Me.ReflectTextToolStripMenuItem.Visible = False
        Me.RegularToolStripMenuItem.Visible = False
        Me.ShadowToolStripMenuItem.Visible = False

        x1 = 0
        y1 = 0
        x2 = Form1.Pic1.Image.Width
        y2 = Form1.Pic1.Image.Height
        SelectRect.Width = Form1.Pic1.Image.Width
        SelectRect.Height = Form1.Pic1.Image.Height

        Dim tmpRec As Rectangle = New Rectangle(x1, y1, x2 - 2, y2 - 2)
        dashPen.DashStyle = Drawing2D.DashStyle.Dash
        dashPen.Color = Color.Silver
        ' Create rectangle for clipping region.
        Form1.Pic1.CreateGraphics.DrawRectangle(dashPen, tmpRec)


    End Sub

    Private Sub CropToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CropToolStripMenuItem.Click
        frmCrop.Show()
    End Sub
End Class
